Attribute VB_Name = "modFuncions"
Public Type AssocData
    MainSolution As String
    SolutionA As String
    SolutionB As String
    SolutionV As String
    SolutionG As String
    A(4) As String
    B(4) As String
    V(4) As String
    G(4) As String
End Type

Private DBConn As New ADODB.Connection
Dim SolutionList() As String

Public Function GetAssoc() As AssocData
    Dim rs As New ADODB.Recordset
    Dim rs2 As New ADODB.Recordset
    Dim SolutionCount As Integer
    Dim i As Integer
    
    'Otvaramo konekciju:
    DBConn.Open ("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & App.Path & "\" & "slagalica.mdb" & ";Persist Security Info=False")
    'Uzimamo sve primerke reci (nisam nikako uspeo da izvedem da
    'SQL uradi selekciju samo onih reci koje imaju bar 4 asocijacije):
    Call rs.Open("SELECT DISTINCT Word FROM Associates", DBConn, adOpenKeyset)
    ReDim tmpSList(rs.RecordCount) As String 'Koristimo ReDim da bismo dinamicki odredili duzinu niza
    Do Until rs.EOF
        Dim dsa As String
        dsa = rs.Fields(0).Value
        'rs.Close
        'Uzimamo iz baze associjacije za trenutnu rec
        Call rs2.Open("SELECT Associate FROM Associates WHERE Word = '" _
                        & dsa & "'", DBConn, adOpenKeyset)
        If rs2.RecordCount > 3 Then  'Prvi test je da li ih ima vise od 3
            'Ako ih ima idemo na drugi test - da li postoji bar 4 njih
            'koje ima ju svojih 4 asocijacija
            Dim InnerSolutionCount As Integer   'Brojac oscijacija za medjuresenje
            InnerSolutionCount = 0
            Do Until rs2.EOF
                'Uzimamo iz baze broj asocijacija za madjuresenje
                'ali ne kreiramo Recordset vec samo proveravamo vrednost polja
                If DBConn.Execute("SELECT COUNT(Associate) FROM Associates WHERE Word = '" _
                                    & rs2.Fields(0).Value & "'").Fields(0) > 3 Then
                    InnerSolutionCount = InnerSolutionCount + 1
                End If
                rs2.MoveNext
            Loop
            If InnerSolutionCount > 3 Then  'Ako medjuresenje ima dovoljno asocijacija
                tmpSList(SolutionCount) = rs.Fields(0).Value 'Zapisujemo resenje
                SolutionCount = SolutionCount + 1 'Povecavamo broj dobrih resenja
            End If
        End If
        rs2.Close   'Zatvaramo Recordset da oslobodimo resurse
        rs.MoveNext
    Loop
    'Ako nema ni jednog odgovarajuceg resenja izlazimo iz funkcije:
    If SolutionCount = 0 Then Exit Function
    ReDim SolutionList(SolutionCount - 1)
    For i = 0 To SolutionCount - 1
        SolutionList(i) = tmpSList(i) 'kopiramo samo one pocetne elemente koji sadrze resenja
    Next i
    GetAssoc.MainSolution = SolutionList(GetRandom(0, SolutionCount - 1))
    rs.Close
    Call rs.Open("SELECT Associate FROM Associates WHERE Word = '" & GetAssoc.MainSolution & "'", DBConn, adOpenKeyset)
    If rs.RecordCount = 4 Then 'ako jeste obilazimo uzimanje slucajnih jer ce ionako svi biti upotrebljeni
        GetAssoc.SolutionA = rs.Fields(0).Value
        rs.MoveNext
        GetAssoc.SolutionB = rs.Fields(0).Value
        rs.MoveNext
        GetAssoc.SolutionV = rs.Fields(0).Value
        rs.MoveNext
        GetAssoc.SolutionG = rs.Fields(0).Value
        rs.MoveNext
    Else
        Dim RndArray() As Integer
        'Dobijamo niz 4 slucajna broja iz intervala 0 do broja asocijacija -1:
        Call GetRndArray(0, rs.RecordCount - 1, 4, RndArray)
        rs.MoveFirst                            'Pomeramo se na pocetak pa tek onda
        rs.Move (RndArray(0))                   'za broj slucajan broj redova jer rs ne podrzava pomeranje na apsolutnu poziciju
        GetAssoc.SolutionA = rs.Fields(0).Value 'i uzimamo vrednost
        rs.MoveFirst                            'Dalje ponavljamo postupak i za ostale kolone
        rs.Move (RndArray(1))
        GetAssoc.SolutionB = rs.Fields(0).Value
        rs.MoveFirst
        rs.Move (RndArray(2))
        GetAssoc.SolutionV = rs.Fields(0).Value
        rs.MoveFirst
        rs.Move (RndArray(3))
        GetAssoc.SolutionG = rs.Fields(0).Value
        rs.Close
        'Uzimamo asocijacije za resenje kolone A
        Call rs.Open("SELECT Associate FROM Associates WHERE Word = '" _
                    & GetAssoc.SolutionA & "'", DBConn, adOpenKeyset)
        Call GetRndArray(0, rs.RecordCount - 1, 4, RndArray) 'Niz 4 slucajna broja
        For i = 1 To 4  'Ne radimo sa 0-based nizom jer je kasnije jednostavnije zbog naziva polja - A1, B3...
            rs.MoveFirst                        'Popunjavamo polja kolone
            rs.Move (RndArray(i - 1))             'na slican samo malo kraci
            GetAssoc.A(i) = rs.Fields(0).Value  'nacin kao sto smo popunili medjuresenja
        Next i
        rs.Close
        'Poavljamo postupak za ostale kolone
        Call rs.Open("SELECT Associate FROM Associates WHERE Word = '" _
                    & GetAssoc.SolutionB & "'", DBConn, adOpenKeyset)
        Call GetRndArray(0, rs.RecordCount - 1, 4, RndArray)
        For i = 1 To 4
            rs.MoveFirst
            rs.Move (RndArray(i - 1))
            GetAssoc.B(i) = rs.Fields(0).Value
        Next i
        rs.Close
        Call rs.Open("SELECT Associate FROM Associates WHERE Word = '" _
                    & GetAssoc.SolutionV & "'", DBConn, adOpenKeyset)
        Call GetRndArray(0, rs.RecordCount - 1, 4, RndArray)
        For i = 1 To 4
            rs.MoveFirst
            rs.Move (RndArray(i - 1))
            GetAssoc.V(i) = rs.Fields(0).Value
        Next i
        rs.Close
        Call rs.Open("SELECT Associate FROM Associates WHERE Word = '" _
                    & GetAssoc.SolutionG & "'", DBConn, adOpenKeyset)
        Call GetRndArray(0, rs.RecordCount - 1, 4, RndArray)
        For i = 1 To 4
            rs.MoveFirst
            rs.Move (RndArray(i - 1))
            GetAssoc.G(i) = rs.Fields(0).Value
        Next i
    End If
    DBConn.Close     'Oslobadjamo sistemske resurse. Ovo automatski poziva i rs.Close
    Set rs = Nothing 'I memoriju
End Function

Private Function GetRandom(First As Integer, Last As Integer) As Integer
    Randomize
    GetRandom = First + Int(Rnd * (Last - First + 1))
End Function


Public Function GetRndArray(First As Integer, Last As Integer, Lenght As Integer, Arr() As Integer)
    Dim tmpArray() As Integer
    ReDim tmpArray(Lenght - 1) As Integer
    Dim i As Integer
    
    Randomize
    tmpArray(0) = GetRandom(First, Last)
    For i = 1 To Lenght - 1
        tmpArray(i) = tmpArray(i - 1)
        Do While IsInArray(tmpArray(i), tmpArray, i - 1)
            tmpArray(i) = GetRandom(First, Last)
        Loop
    Next i
    Arr = tmpArray
End Function

Private Function IsInArray(Number As Integer, Arr() As Integer, Offset As Integer) As Boolean
    Dim i As Integer
    IsInArray = False
    For i = 0 To Offset
        If Arr(i) = Number Then IsInArray = True
    Next i
End Function


